unit mpxfmem;
{
  MPXF Memory Unit
}

interface
 Const
  MaxMem      = 200;
  SongSize    = 200;
  MaxSongs    = 15000;

 Var
   Hdl     : Word;          { Handle for Extended memory allocated }
   data:array[1..MaxMem] of string[SongSize];
   xmscount:longint;
   memblocks:integer;

{*** uses mpxfvars;}
procedure ReleaseXMS;
procedure Init_XMS;
procedure SetXMSMemory;
{procedure PrepareAdd;}
{procedure putsong(thesong:song);}
procedure savemem(p:integer);
{procedure putsongat(position:integer;thesong:song);}
{function getsonginfo(position:integer) : songname;
function getsongall(position:integer) : songname;
function getsongpath(position:integer) : songname;}
implementation
uses xms,lcd,crt;


 Var
  numhdl   : integer;
  HiMemOK : boolean;


procedure Init_XMS;
begin
  xmscount:=0;
  memblocks:=0;
  numhdl:=0;
  HiMemOK := XMSDriverLoaded;
{  WriteLn('XMS Memory=', HiMemOK);}
  IF NOT HiMemOK THEN begin
     writeln('Unable to allocate XMS');
     writeln('Make sure you have HIMEM.SYS loaded in your config.sys file.');
     Halt;
  end;
  Hdl := XMSAllocateBlock((MaxSongs * SongSize + 1023) DIV 1024);
end;

procedure SetXMSMemory;
begin
    inc(memblocks);
    savemem(memblocks);
    dec(memblocks); { Go back }
end;

procedure savemem(p:integer);
  var i:integer;
  begin
{    for i := 1 to maxmem do writeln(data[i]);
    readln;}
      IF NOT XMSMoveDataTo(@data, sizeof(data), Hdl, (p - 1) *
        sizeof(data)) THEN
        WriteLn('Error on Move to XMS: ',I,' Error: ', XMSErrorCode);
      for i := 1 to maxmem do data[i] := '';
  end;


procedure ReleaseXMS;
  var l:integer;
  begin
      if not XMSReleaseBlock(Hdl) then begin
         writeln('Error Releasing!');
         LCDClear;
         LCDPrintAt(1,'Error Releasing');
         LCDPrintAt(2,'  Memory!');
       end;
  end;

begin
end.