unit mpxftsrb;
{ TSR Routines }
interface

Procedure MainTSRProc;
procedure doit;

implementation

Uses lcd,Dos ,config
 {$IFDEF serkey} ,mpxfkey{$ENDIF};

type
  attr_rec= record
     name:string;
  end;

  scroll_rec = record
    on:boolean;
    p:integer;
    dir:integer;
    pause:integer;
    delay:integer;
  end;

  line_rec = record
    LineScroll:boolean;
    LineValue:byte;
    LineString:string[50];
    LineTime:word;
  end;

  Browse_Rec = record
    filestring:string[80];
  end;

  line_type = record
    Values:byte;
    scrolling:boolean;
    current:byte;
    DelayTime:word;
    data:array[1..4] of line_rec;
  end;
Var
    Paused:boolean;
    DrawLogo:boolean;
    Printing:boolean;
    BrtLine, BrtCol, CodecLine, CodecCol,CpuLine, CpuCol, FileLine: Byte;
    InfoLine, InfoStartCol, InfoEndCol, MeterLine, MpxLine, MpxCol: Byte;
    PauseLine, PauseCol, PLLine, PLCol, PLLen, SampLine, SampCol: Byte;
    MpxStat1Line, MpxStat1Col, MpxStat2Line, MpxStat2Col: Byte;
    TimeLine, TimeStartCol, TimeEndCol, VolLine, VolCol: Byte;
    DelayFactor,    LCDLines,    LCDLen : byte;
    RefreshDelay,TimetoRefresh:word;
    scrolldelay,scrollpause:byte;
    ShowNumLock:boolean;
    AllStats:string;
    c:char;
    i,j,k:integer;
    changes:boolean;
    codefile:string[30];

    BrowseString:string[80];

    PlayFile:string;
    attrinfo:array[1..6] of attr_rec;
    displayit:array[1..4] of boolean;
    b:string;
    a:byte;
    w:word;

    keyPlayView,keyScrollToggle,keyLineUp,keyLineDown,keyLineToggle:byte;
    InKeyRoutine:boolean;

    PauseCheck:boolean;
    ViewFiles:boolean;

    Count:Byte;                       { Counts Seconds                }
    Orgint9:Procedure;

    itson:boolean;
    LCDLineSet:array[1..4] of line_type;
    LCDSelected:byte;
    Scrolling:array[1..4] of scroll_rec;
    ExitPlayer:boolean;
    KeyboardEnabled :boolean;
    NumLockStatus:boolean;


function FileExists(var FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure delay(d:word);
 var k,j:word;
  begin
    k := d * 4000;
    for j := 1 to k do ;
  end;

function strr(b:word):string;
var s1:string[5];
  begin
    s1:='';
    str(b,s1);
    strr:=s1;
  end;

Function ShiftState : Byte;
Var
  Regs : Registers;
begin
  Regs.Ah := 2;
  Intr($16, Regs);
  ShiftState := Regs.Al;
end;

Function NumLockOn : Boolean;
begin
  NumLockOn := (ShiftState and 32) <> 0;
end;

procedure eq_bars;
begin
  delay(50);
  initlcd;
  delay(50);
  lcddefinechar(7,  0,0,0,0,0,0,0,31);
  lcddefinechar(6, 0,0,0,0,0,0,31,31);
  lcddefinechar(5, 0,0,0,0,0,31,31,31);
  lcddefinechar(4, 0,0,0,0,31,31,31,31);
  lcddefinechar(3, 0,0,0,31,31,31,31,31);
  lcddefinechar(2, 0,0,31,31,31,31,31,31);
  lcddefinechar(1, 0,31,31,31,31,31,31,31);
  lcddefinechar(0, 31,31,31,31,31,31,31,31);
  delay(50);
  lcdclear;
end;

procedure clear_bars;
begin
  lcddefinechar(7,  0,0,0,0,0,0,0,0);
  lcddefinechar(6,  0,0,0,0,0,0,0,0);
  lcddefinechar(5,  0,0,0,0,0,0,0,0);
  lcddefinechar(4,  0,0,0,0,0,0,0,0);
  lcddefinechar(3,  0,0,0,0,0,0,0,0);
  lcddefinechar(2,  0,0,0,0,0,0,0,0);
  lcddefinechar(1,  0,0,0,0,0,0,0,0);
  lcddefinechar(0,  0,0,0,0,0,0,0,0);
end;

procedure TSRLogo;
 var c,i,j,k,a,d:integer;
 begin
   d:= 4;
   if (lcdlines = 4) and (lcdlen > 20) then d := 4;
   if lcdlines = 2 then d := 8 else d:=4;
   if (lcdlines = 2) and (lcdlen > 20) then d := 4;
   for a:= 1 to 20 do
    for i := 1 to lcdlines do begin
      LCDCursor(i,1);
      for j := 1 to lcdlen do
        begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
    end;
    c:= lcdlen div 2;
    c:=c-3;
    delay(10);
    LCDCursor(1,c);
    LCDPrint('MpXT TSR');
    LCDCursor(2,c);
    LCDPrint(' v'+version+'    ');
if lcdlines > 2 then begin
    LCDCursor(3,c);
    LCDPrint('        ');
    LCDCursor(4,c);
    LCDPrint('        ');
end;
    for a := 1 to 55 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
        if a= 40 then begin
          LCDCursor(2,c);
          LCDPrint(' Loaded ');
        end;
      end;
      for a := 0 to 8 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d);
        end;
     end;
 end;

procedure DoConfig;
var code,data,h:integer;
  begin
    if not (openconfig('mpxttsr.cfg')) then begin
      writeln('MPXTTSR.CFG not found!');
      halt(1);
    end;

    DelayFactor := ReadWord('TSR Settings','DelayFactor');
    RefreshDelay := ReadWord('TSR Settings','RefreshDelay');
    ScrollDelay := readword('TSR Settings','ScrollDelay');
    ScrollPause := readword('TSR Settings','ScrollPause');

    PauseCheck := ReadBoolean('MPXPlay Settings','PauseCheck');
    BrtLine:=ReadWord('MPXPlay Settings','BrtLine'); {new 1.5}
    BrtCol:=ReadWord('MPXPlay Settings','BrtCol'); {new 1.5}
    CodecLine:=ReadWord('MPXPlay Settings','CodecLine'); {new 1.5}
    CodecCol:=ReadWord('MPXPlay Settings','CodecCol'); {new 1.5}
    CpuLine:=ReadWord('MPXPlay Settings','CpuLine'); {new 1.5}
    CpuCol:=ReadWord('MPXPlay Settings','CpuCol'); {new 1.5}
    FileLine:=ReadWord('MPXPlay Settings','FileLine');    {new 1.44}
    InfoLine:=ReadWord('MPXPlay Settings','InfoLine');
    InfoStartCol:=ReadWord('MPXPlay Settings','InfoStartCol'); {new 1.44}
    InfoEndCol:=ReadWord('MPXPlay Settings','InfoEndCol'); {new 1.44}
    MeterLine:=ReadWord('MPXPlay Settings','MeterLine');  {new 1.44}
    MpxLine:=ReadWord('MPXPlay Settings','MpxLine'); {new 1.44}
    MpxCol:=ReadWord('MPXPlay Settings','MpxCol'); {new 1.44}
    PauseLine:=ReadWord('MPXPlay Settings','PauseLine');
    PauseCol:=ReadWord('MPXPlay Settings','PauseCol'); {new 1.44}
    PLLine:=ReadWord('MPXPlay Settings','PLLine'); {new 1.44}
    PLCol:=ReadWord('MPXPlay Settings','PLCol'); {new 1.44}
    PLLen:=ReadWord('MPXPlay Settings','PLLen'); {new 1.44}
    SampLine:=ReadWord('MPXPlay Settings','SampLine');{new 1.5}
    SampCol:=ReadWord('MPXPlay Settings','SampCol');  {new 1.5}
    MpxStat1Line:=ReadWord('MPXPlay Settings','Stat1Line'); {new 1.5}
    MpxStat1Col:=ReadWord('MPXPlay Settings','Stat1Col'); {new 1.5}
    MpxStat2Line:=ReadWord('MPXPlay Settings','Stat2Line'); {new 1.5}
    MpxStat2Col:=ReadWord('MPXPlay Settings','Stat2Col'); {new 1.5}
    TimeLine:=ReadWord('MPXPlay Settings','TimeLine'); {new 1.44}
    TimeStartCol:=ReadWord('MPXPlay Settings','TimeStartCol'); {new 1.44}
    TimeEndCol:=ReadWord('MPXPlay Settings','TimeEndCol'); {new 1.44}
    VolLine:=ReadWord('MPXPlay Settings','VolLine');
    VolCol:=ReadWord('MPXPlay Settings','VolCol'); {new 1.44}

    {$IFDEF serkey}
    if (ReadBoolean('Serial Keypad','Enabled')) then
      begin
        SerialOn;
        KeySetBaud(ReadWord('Serial Keypad','BaudRate'));
        KeySetBits(ReadWord('Serial Keypad','Stopbits'));
        KeySetPort(ReadWord('Serial Keypad','Comport'));
        KeySetBuffer(ReadWord('Serial Keypad','BufferLength'));
        codefile := ReadString('Serial Keypad','Codefile');
      end;
    {$ENDIF}
    keyLineToggle := readword('Keyboard Settings','ChangeLineValue');
    keyScrollToggle := readword('Keyboard Settings','ScrollingValue');
    keyLineup := readword('Keyboard Settings','LineUpValue');
    keyLinedown := readword('Keyboard Settings','LineDownValue');
    keyboardenabled := readboolean('Keyboard Settings','KeyboardEnabled');
    keyPlayView := readword('Keyboard Settings','PlayViewToggle');
    DrawLogo := readboolean('TSR Settings','DisplayLogo');

    ShowNumLock := readboolean('LCD Output','ShowNumLock');

    for code := 1 to 4 do
      for data := 1 to 4 do begin
        LCDLineSet[code].Data[data].LineString :=
          readstring('Line'+strr(code),'Line'+chr(64+data)+'Value');
        LCDLineSet[code].Data[data].LineTime :=
          readword('Line'+strr(code),'Line'+chr(64+data)+'Time');
        LCDLineSet[code].Data[data].LineScroll :=
          readboolean('Line'+strr(code),'Line'+chr(64+data)+'Scroll');
      end;
    for code := 1 to 4 do begin
      for data := 1 to 4 do begin
{        for h := 1 to length(LCDLineSet[code].Data[data].LineString) do
          LCDLineSet[code].Data[data].LineString[h] := upcase(LCDLineSet[code].Data[data].LineString[h]); Removed for MPXT}
        if LCDLineSet[code].Data[data].LineTime <> 0 then begin
          LCDLineSet[code].Values := data;
          LCDLineSet[code].Data[data].LineTime := LCDLineSet[code].Data[data].LineTime div DelayFactor;
        end;
      end;
      if LCDLineSet[code].Values = 0 then LCDLineSet[code].Values := 1;

    end;

    closeconfig;

    ReadLCDSettings;
    LCDLen := width;
    LCDLines := lines;
  end;

FUNCTION GetCharC( X,Y :WORD; VAR Attrib:BYTE ) :CHAR;
VAR
   Ofs :WORD;
BEGIN
                        { NOTE: Change the Segment from $B800 }                        {       to $B000 for MonoChrome.      }
  Ofs := ((Y-1) * 160) + ((X SHL 1) - 1);
  Attrib := MEM[$B800:Ofs];
  GetCharC := CHR( MEM[$B800:Ofs-1] );
END;

FUNCTION GetChar( X,Y :WORD) :CHAR;
var b:byte;
  begin
    getchar := getcharc(x,y,b);
  end;

{1.44}
 Function filename:string;      {Grabs the 8.3 filename from the screen}
  Var
   i,j:integer;                        {Mpxplay 1.44 doesn't display the 8.3}
   ch:char;                             {in a separate location, just the}
  Begin                                 {full path at the center of the}
   b:='';                               {screen. More code is necessary since}
   i:=80;                               {we have less to work with}
   repeat                       {Quick and dirty way to avoid reading all}
    i:=i DIV 2;                 { 80 characters just to get the filename}
   until (getchar(i,FileLine)='-') or (i<3);
   repeat
    i:=i+1;                     {Grab the full file path, right up to the dot}
    ch:=getchar(i,FileLine);
    b:=b+ch;
   until (ch='.') OR (i=77);
   if i<77 then                 {Add the file extension to the string}
    for j:=i+1 to i+3 do
     b:=b+getchar(j,FileLine);
   i:=length(b);                {Trim the beginning part of the file path}
   repeat                       { leaving just 'filename.ext'}
    i:=i-1;
   until (b[i]='\') OR (i=1);
   b:=copy(b,i+1,length(b)-i);
   filename:=b;                 {Return the result}
  End;

{1.44}
 Function mp3bar:string;               {Grabs the level meter from the screen}
  Var
   i,start,stop:integer;
  Begin
   b:='';
   start:=61;
   stop:=77;
   if lcdlen>=20 then begin start:=59; stop:=79; end;
   for i :=start to stop do {a subset of the "58 to 80" eq}
    begin
     if getchar(i,MeterLine) = #186 then b := b + chr(255) else b := b + ' ';
    end;
   mp3bar := b;
  End;

 Function GrabData(x,y:Byte):string; {Reads data from any portion of the}
  Var                                   {screen, where x=x-coordinate}
   ch: Char;
   done: Boolean;
  Begin
   b:='';
   done:=false;
   while (x<=80) and (not done) do
    Begin
     ch:=getchar(x,y);
     if ch<>#179 then
      b:=b+ch
       else done:=true;
     inc(x);
    End;
   {Remove any spaces}
   while (length(b)>0) AND (b[length(b)]=' ') do
    b:=copy(b,1,length(b)-1);
   while (length(b)>0) AND (b[1]=' ') do
    b:=copy(b,2,length(b)-1);
   GrabData:=b;
  End;

 {for 1.44}
 Function volume:string;               {Grabs the Mpxplay's volume from the}
  Var                                   {screen}
   i:integer;
  Begin
{   b:='Vol:';                          {Start with 'Vol:' then add the}
 {   for i:=0 to 2 do                     {numeric value}
{     b:=b+getchar(VolCol+i,VolLine);
    volume:=b;                         {return the result}
   volume:=grabdata(volcol,volline);
  end;

{New 1.5}
 Function Samples:string;              {Grabs the samples/total from the}
  Var                                   {screen}
   i:integer;
  Begin
   b:='';
    for i:=0 to 10 do                  {numeric value}
     b:=b+getchar(SampCol+i,SampLine);
    Samples:=b;                        {return the result}
   end;

{New 1.5}
 Function Codec:string;                {Grabs the samples/total from the}
  Var                                   {screen}
   i:integer;
  Begin
   b:='';
    for i:=0 to 7 do                   {numeric value}
     b:=b+getchar(CodecCol+i,CodecLine);
    Codec:=b;                          {return the result}
   end;

{New 1.5}
 Function Cpu:string;                  {Grabs the samples/total from the}
  Var                                   {screen}
   i:integer;
  Begin
   b:='';
    for i:=0 to 7 do                   {numeric value}
     b:=b+getchar(CpuCol+i,CpuLine);
    Cpu:=b;                            {return the result}
   end;

{New 1.5}
 Function Bitrate:string;
  Var
   xxbit:byte;
   brint:word;
  Begin
   b:='';
    for i:=0 to 7 do   {col=51}
     b:=b+getchar(BrtCol+i,BrtLine);
   if (b[5]='b') and (b[6]='i') and (b[7]='t') then
    begin                                                     {case1: wav}
     xxbit:=((ord(b[2])-48)*10)+(ord(b[3])-48);         {xx bit}
     b:='';
     for i:=9 to 13 do
      b:=b+getchar(BrtCol+i,BrtLine);                   {xxxxx Hz}
     val(b,brInt,i);                                    {convert to integer}
     brInt:=brInt div 100;                              {xxx kHz*10}
     brInt:=brInt*xxbit;                                {mult by 'xx bit'}
     if (getchar(BrtCol+18,BrtLine)='S') or (getchar(BrtCol+19,BrtLine)='S') then
      brInt:=brInt shl 1;                               {if stereo mult by 2}
     brInt:=brInt div 10;                               {div10 to get bitrate}
     str(brInt,b);                                      {convert back to str}
     b:=b+'k';                                          {xxxxK}
    end
     else if b[3]='/' then                                    {case2: ape}
      begin
       b:=copy(b,4,5);                            {xx.x%}
      end
     else                                                     {case3: mp3/ogg}
      begin
       b:=copy(b,1,3)+'kb';                       {xxxKb}
      end;
   bitrate:=b;
  End;

{New 1.5}
 Function MpxplayStats1: String;
  Var
   x,y,c: Byte;
   ch: Char;
  Begin
   b:='';
   i:=0;
   while (i<8) do
    begin
     ch:=GetCharC(MpxStat1Col+i,MpxStat1Line,c);
     if (c and $F)=11 then
      b:=b+ch+getchar(MpxStat1Col+i+1,MpxStat1Line);
     inc(i,2);
    end;
   MpxPlayStats1:=b;                            {return the result}
   b:='';
  End;

 Function MpxplayStats2: String;
  Var
   x,y,c: Byte;
   ch: Char;
  Begin
   b:='';
   i:=0;
   while (i<13) do
    begin
     ch:=GetCharC(MpxStat2Col+i,MpxStat2Line,c);
     if (c and $f)=11 then  {cyan}
      b:=b+ch+getchar(MpxStat2Col+i+1,MpxStat2Line);
     inc(i,4);
    end;
   ch:=GetCharC(MpxStat2Col+16,MpxStat2Line,c);
   if (c and $f)=11 then
    b:=b+ch+getchar(MpxStat2Col+17,MpxStat2Line);
   ch:=GetCharC(MpxStat2Col+18,MpxStat2Line,c);
   if (c and $f)=11 then
    b:=b+ch+getchar(MpxStat2Col+19,MpxStat2Line);
   MpxPlayStats2:=b;                            {return the result}
   b:='';
  End;

 {function MP3Time:string;
  var
    i:integer;
    begin
      b:='';
      for i := bounds[TimeBound].start+1 to bounds[TimeBound].theend-1 do b:= b + getchar(i,StatLine);
      a:=pos(')',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,2,length(b));
      mp3time := b;
      b:='';
    end;}

{for 1.44}
function MP3Time:string;       {Grabs the current 'song-time' from the screen}
 var                           { e.g. '0:36/4:22'}
  i:integer;
  c:char;
    begin
     b:='';                    {start with an empty string}
     i:=TimeStartCol;             {start reading at position 58,7}
     while i<= TimeEndCol do      {stop reading at position 70,7}
      begin
       c:=getchar(i,TimeLine);
       if c='.' then           {don't add the tenths/sec to the string...}
        begin                  { tenths/sec doesn't display well on lcds}
         c:=#32;
         i:=i+1;
        end;
       if c<>#32 then b:=b+c;  {add the character if it's not a space}
       i:=i+1;
      end;
     mp3time:=b;               {return the result}
     b:='';                    {clearing the string, because it was}
    end;                       { done in the old code}

{function PlayList:string;
  var
    i:integer;
    begin
      b:='';
      for i:= 1 to 11 do b:=b + getchar(bounds[PlayListBound].start+i,StatLine);
      a:=pos(')',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,1,length(b));
      PlayList := b;
    end;}

{1.44}
 Function PlayList:string;             {Grabs info showing where you're at,}
  Var                                  {in the playlist, from the screen e.g.}
   i:integer;                          {'1/11'}
   c:char;
  Begin
   b:='';
   for i:=0 to PLLen-1 do        {Can be up to 9 digits long}
    begin
     c:=getchar(PLCOL+i,PLLine); {get the character}
     if c<>#32 then b:=b+c;      {if it's not a space, add it to the string}
    end;
   PlayList:=b;                  {return the result}
  End;

function CurrentSong:string;
 begin
   b:=playlist;
   currentsong := copy(b,1,pos('/',b)-1);
 end;

{
function PreLoad:boolean;
var b:boolean;
    a:byte;
  begin
    b:=false;
    b:= (getchar(1,InfoLine) = 'P');
    b:=b and (getchar(2,InfoLine) = 'r');
    b:=b and (getchar(3,InfoLine) = 'e');
    b:=b and (getchar(4,InfoLine) = 'l');
    PreLoad := b;
  end;}

{1.44 -- untested}
function PreLoad:boolean;
var b:boolean;
    a:byte;
  begin
    b:=false;
    b:= (getchar(34,InfoLine) = 'P');
    b:=b and (getchar(35,InfoLine) = 'r');
    b:=b and (getchar(36,InfoLine) = 'e');
    b:=b and (getchar(37,InfoLine) = 'l');
    PreLoad := b;
  end;

procedure DoNumLock;
var test:boolean;
  begin
    if ShowNumLock then begin
      if numlockon <> numlockstatus then
        begin
          numlockstatus := numlockon;
          LCDCursor(LCDLines,LcdLen);
          if numlockstatus then LCDPrint(chr(165)) else LCDPrint(' ');
        end;
    end;
  end;

function changefactor:string;
    begin { This is to make sure that we don't think a song title is Preload }
      dec(TimetoRefresh);
      if (TimetoRefresh = 0) and (ItsOn) then
      begin
        TimetoRefresh := RefreshDelay;
        DoNumLock;
        if PreLoad then changefactor := '=' else changefactor:={playlist+}filename;
      end else changefactor := playfile;
    end;

function TimeVol:string;
  var
    b: string[30];
    begin
      b:= mp3time;
      b := copy(b,1,pos('/',b)-1);
      b := ' ' + b + ' '+'Vol:'+volume;
      timevol := b;
    end;

function TimePlaylist:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    b:=  b + ' ' + playlist;
    timeplaylist := b;
    b:='';
  end;

{From MPXF}
{function eqbars(ln:byte):string;
  var
      h:char;
      bar:byte;
      start:byte;
      numinc:word;
      count:byte;
  begin
    b:='';
    start := 3;
    if ln > 28 then ln := 28;

    numinc := 28 div ln; ( 32 bars )
    count := 1;
    while (count < 28) do
    begin
      bar:=start;
      h:='.';
      while ((bar-start) <= 18) and (h<>chr(186)) do
        begin
          h:=getchar(count,bar);
          if h<>chr(186) then inc(bar,2);
        end;
      bar := bar - start;
      bar := bar div 2;
      if (bar>0) then dec(bar);
      if (bar >= 8) then b:=b+' ' else
        b:=b+chr(bar);
      inc(count,numinc);
    end;
    eqbars := b;
  end;}

{From MPXF}
{function ceqbars(s,e,ln:byte):string;
  var
      h:char;
      bar:byte;
      start:byte;
      numinc:word;
      count:byte;
  begin
    b:='';
    start := s;
    if ln > 28 then ln := 28;

    numinc := 28 div ln; { 32 bars }
 {   count := 1;
    while (count < 28) do
    begin
      bar:=start;
      h:='.';
      while ((bar-start) <= e) and (h<>chr(186)) do
        begin
          h:=getchar(count,bar);
          if h<>chr(186) then inc(bar,1);
        end;
      bar := bar - start;
      if e = 4 then bar := (2*bar) else
      if e = 6 then begin
        if bar >= e then bar := bar + 1; end
        else bar := bar;
      if (bar >= 8) then b:=b+' ' else
        b:=b+chr(bar);
      inc(count,numinc);
    end;
    ceqbars := b;
  end;}

{1.5 beta1  New, and not guaranteed bug free}
{function ceqbars(t,s,e,ln:byte):string;
  Const
   EQ3lt:Array[1..6] of Byte=(0,2,3,5,6,8);
  Var
      h:char;
      bar:byte;
      numinc,countw:word;
      count:byte;
  Begin
    b:='';
    if ln > 28 then ln := 28;                  {Use the first 28 columns}
{    numinc:=280 div ln;
    countw:=10;

   while (countw < 280) do                   {Column loop}
{    begin
     bar:=0;                                   {Init bar value to zero}
{     h:='.';       {for 1,15 bar<(15-1)+1}
{     count:=countw div 10;
     while (h<>#186) and (bar+s<=e) do          {Row Loop}
{       begin                                     {Count down till you hit}
{        h:=getchar(count,bar+s);                  {the eq.  Gives you a}
{        inc(bar);                                 {mirror image of what the}
{       end;                                       {eq looks like}
{     case t of
      11: bar:=bar*79 DIV 150;
      22: dec(bar);
      31: bar:=EQ3lt[bar];
      41: bar:=bar shl 1;
      42: bar:=(bar shl 1)-2;
     end;
     if bar<88 then b:=b+chr(bar) else b:=b+' ';
     inc(countw,numinc);
    end;
   ceqbars := b;
  End;}

{1.5 beta2  New, and not guaranteed bug free}
{mpxplay 1.42's & 1.50 the eq is 32 bars wide, 15 tall. mpx1.42: 21 tall}
Function ceqbars(t,s,e,ln:byte):string;
 Const
  EQ3lt:Array[1..6] of Byte=(0,2,3,5,6,8);
 Var
  h:char;
  bar:byte;
  numInc, xCoord, count:byte;

 Begin
  b:='';
  if ln > 28 then ln := 28;                  {Use the first 28 columns}
  numInc := 28 div ln;                       {numInc is the x-increment}
  xCoord := 1;
  count:=1;
  while (count < ln) do                      {Column loop}
   begin
    bar:=0;                                   {Init bar value to zero}
    h:='.';
    while (h<>#186) and (bar+s<=e) do          {Row Loop}
     begin                                     {Count down till you hit}
      h:=getchar(xCoord,bar+s);                 {the eq.  Gives you a}
      inc(bar);                                 {mirror image of what the}
     end;                                       {eq looks like}
    case t of
      11: bar:=bar*79 DIV 150;
      22: dec(bar);
      31: bar:=EQ3lt[bar];
      41: bar:=bar shl 1;
      42: bar:=(bar shl 1)-2;
     end;
    if bar<88 then b:=b+chr(bar) else b:=b+' ';
    inc(xCoord,numInc);
    inc(count);
   end;
  ceqbars := b;
 End;


function split4eq(l:byte):string;
  begin
    case l of
{      1: split4eq := ceqbars(1,4,lcdlen);
      2: split4eq := ceqbars(6,4,lcdlen);
      3: split4eq := ceqbars(11,4,lcdlen);
      4: split4eq := ceqbars(16,4,lcdlen);}
      1: split4eq := ceqbars(41,1,4,lcdlen);
      2: split4eq := ceqbars(42,4,8,lcdlen);
      3: split4eq := ceqbars(42,8,12,lcdlen);
      4: split4eq := ceqbars(42,12,16,lcdlen);
    end;
  end;

function split3eq(l:byte):string;
  begin
    case l of
{      1: split3eq := ceqbars(1,6,lcdlen);
      2: split3eq := ceqbars(7,6,lcdlen);
      3: split3eq := ceqbars(14,6,lcdlen);}
      1: split3eq := ceqbars(31,1,6,lcdlen);
      2: split3eq := ceqbars(31,6,11,lcdlen);
      3: split3eq := ceqbars(31,11,16,lcdlen);
    end;
  end;

function split2eq(l:byte):string;
  begin
    case l of
   {   1: split2eq := ceqbars(4,8,lcdlen);
      2: split2eq := ceqbars(12,8,lcdlen);}
      1: split2eq:=ceqbars(21,1,8,lcdlen);
      2: split2eq:=ceqbars(22,8,16,lcdlen);
    end;
  end;

function SingleTime:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    Singletime := b;
    b:='';
  end;

function TimeEqBitrate: String;
 begin
   b:=singletime;
   if length(b)<5 then b:=' '+b;
   b:=b+' '+ceqbars(11,1,16,lcdlen-12)+' '+bitrate;
   TimeEqBitrate:=b;
   b:='';
 end;

Function SongnumSong: String;
 begin
  b:=playlist;                       {Get the songnumber/total}
  if (b<>'1/1') and (b<>'0/0') then   {If more than one song}
   begin
    b:=copy(b,1,pos('/',b)-1);         {Add the songnum}
    if length(b)<2 then b:='0'+b;      {if songnum<10 add a zero}
    b:=b+' ';                          {Add a space to the end}
   end
    else b:='';                       {else clear the string is only one song}

  b:=b+attrinfo[2].name;             {Add the songname to the string}
  SongnumSong:=b;
  b:='';
 end;

function center(const ab:string):string;
var c:string;
 begin
   c := ab;
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function centerchop(const ab:string):string;
var c:string;
 begin
   c := ab;
   if (length(c) > LCDLEN) then c := copy(c,1,lcdlen);
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   centerchop := c;
 end;

function grabrange(l, x1:byte):string;
  var
    g:string[90];
    a:byte;
    c:char;
  begin
    g:='';
    a := x1;
    c := ' ';
    while (a<=80) and (c <> '') do
    begin
      c := getchar(a,l);
      inc(a);
      if (c<> '') then begin
        if (length(g) > 0) and (g[length(g)] = ' ') then
        begin
          if (c<>' ') then g := g + c;
        end
        else g := g + c;
      end;
    end;
{    if (l>=50) or (l=BracketLine) then grabrange := ' ' else}
    if (l>=50) or (l=FileLine) then grabrange := ' ' else  {1.44}
     grabrange := g;
  end;

function getblueline:byte;
var
 l:byte;
 at:byte;
 begin
    {l := BracketLine;}
    l:=FileLine;      {1.44}
    at := 0;
    while (l<50) and (at<=15) do
    begin
      inc(l);
      c := getcharc(20,l,at);
    end;
    getblueline := l;
 end;

function getmp3dir:string;
var
 l:byte;
 start:boolean;
 at:byte;
 b,f:string[80]; {changed from string; to string[80] to save stack space}
 begin
    {l:=startline+1;}
    l:=FileLine; {this makes more sense than orig code}
    at := 5;
    start:=false;
    while (at<=80) do
    begin
      inc(at);
      c := getchar(at,l);
      if start then b := b + c;
      if (c='\') and (not start) then
      begin
        start := true;
        b := '';
      end else
      if (c='\') and (start) then begin
        f := copy(b,1,length(b)-1);
        b := '';
      end;
    end;
    getmp3dir := f;
 end;

function BrowseLine:string;
var
  at:byte;
  found:boolean;
  l:byte;
  begin
    at := 1;
    found := false;
    l:=getblueline;
    while (at<50) and (not found) do
    begin
      inc(at);
      if getchar(at,l) = '' then found := true;
    end;
    if not found then at := 2 else inc(at);

    BrowseLine := grabrange(l,at);
  end;

 FUNCTION Bin2BCD(Bin:Byte): Byte;{ xlate binary to BCD... }
  Begin
   Bin2BCD := (Bin mod 10) or Byte((Bin div 10) shl 4);
  End; {Bin2BCD}

 Function BCD2Bin (BCD:Byte): Byte; { xlate BCD to binary... }
  Begin
    BCD2Bin := (BCD AND $0F) + ((BCD SHR 4) * 10);
  End; {BCD2Bin}

 Function RTCbusy: Boolean; { RTC time/date being updated?... }
  Begin
   Port[$70] := $A;
   RTCbusy := (Port[$71] AND 128) = 128;
  End; {RTCbusy}

 Function ReadReg(Reg:Byte): Byte; { read an RTC register... }
  Begin
   while RTCbusy do;
   Port[$70] := Reg;
   ReadReg := Port[$71];
  End; {ReadReg}

 Function CurrentTime(military: Boolean): String;
  Var
   Hr,Min,Sec, temphr: Byte;
   temp,temp2: String[2];
  Begin
   Sec := ReadReg(0);
   Min := ReadReg(2);
   Hr := ReadReg(4);
   temphr := Hr;
   Hr := Hr and not $80;
   if (ReadReg($B) and 4) = 4 then { translate Bin to BCD }
    Begin
     Sec := Bin2BCD(Sec);
     Min := Bin2BCD(Min);
     Hr := Bin2BCD(Hr);
    End; {IF}
   if (ReadReg($B) and 2) <> 2 then  { RTC in 12-hr mode?... }
   if (temphr and 128) = 128 then { P.M.? }
    Begin
     if (Hr < 12) then inc(Hr,$12);
    End
     Else if Hr = $12 then Hr := 0;
   {Now that we know what we're starting with, now convert}
   temp:='';
   if not military then
    Begin
     if Hr>=$12 then
      Begin
       if (Hr=$20) or (hr=$21) then
        hr:=(hr and $F)+8
         else dec(Hr,$12);
       temp:='pm';
      End
       Else
        temp:='am';
     if Hr=0 then Hr:=$12;
    End;
   if (military) or (((Hr and $F0) shr 4) > 0) then
    temp2:=char(((Hr and $F0) shr 4)+48)
     else temp2:='';
   CurrentTime:=temp2+char((Hr and $0F)+48)+':'+
                  char(((Min and $F0) shr 4)+48)+char((Min and $0F)+48)+'.'+
                  char(((Sec and $F0) shr 4)+48)+char((Sec and $0F)+48)+temp;
  End;

 Function CurrentDate(european:Boolean): String;
  Var
   Cent,Yr,Mth,Day: Byte;
   temp:string[1];
  Begin
   Cent:=ReadReg($32);
   if european=false then
    begin
     Day:=ReadReg(7);
     Mth:=ReadReg(8);
    end
     else
      begin
       Mth:=ReadReg(7);      {If European date wanted,}
       Day:=ReadReg(8);       {switch month and day around}
      end;
   Yr:=ReadReg(9);
   if (ReadReg($B) AND 4) = 4 then
    Begin {Translate Binary to BCD}
     Cent:=Bin2BCD(Cent);
     Day:=Bin2BCD(Day);
     Mth:=Bin2BCD(Mth);
     Yr:=Bin2BCD(Yr);
    End; {IF}   {Whoever said BCD to string conversions were pretty?}
   if ((Mth and $F0) shr 4) > 0 then     {If first digit of the month is zero}
    temp:=char(((Mth and $F0) shr 4)+48)  {use it to start off the string}
     else temp:='';
   CurrentDate:=temp+char((Mth and $0F)+48)+
                 '/'+char(((Day and $F0) shr 4)+48)+char((Day and $0F)+48)+
                 '/'+char(((cent and $F0) shr 4)+48)+char((cent and $0F)+48)+
                     char(((yr and $F0) shr 4)+48)+char((yr and $0F)+48);
  End; {GetDate}

 Function EchtZeller: String;
  Var
   Day,Mth,Yr,Cent: Byte;
   K, h : word ;
   J, m, q : word;
  Begin
   Day := ReadReg(7);
   Mth := ReadReg(8);
   Yr := ReadReg(9);
   Cent:=ReadReg($32);
   if (ReadReg($B) AND 4) <> 4 then
    Begin {Translate BCD to binary}
     Cent:=BCD2Bin(Cent);
     Day:=BCD2Bin(Day);
     Mth:=BCD2Bin(Mth);
     Yr:=BCD2Bin(Yr);
    End; {IF}
   J:=Cent*100+Yr;
   m:=Mth;
   q:=Day;
   if m < 3 then begin Inc(m, 12) ; Dec(J) end ;
   K := J mod 100 ; J := J div 100 ;
   h := q + (m+1)*26 div 10 + K + K div 4 ;
   h := h + J div 4 + 5*J ; { Z had -2*J; +5*J avoids negative }
   { Now adjust to ISO 8601}
   h:=Succ((h+5) mod 7) ;
    case h of
     7: EchtZeller:='Sunday';
     1: EchtZeller:='Monday';
     2: EchtZeller:='Tuesday';
     3: EchtZeller:='Wednesday';
     4: EchtZeller:='Thursday';
     5: EchtZeller:='Friday';
     6: EchtZeller:='Saturday';
    end;
  End; {EchtZeller}


function GetMP3Info(var inst:string):string; {changed to var to save stack}
var                                           {space}
  s:string;
  h:byte;
  begin
    s:='';
    changes := false;
    if inst='M3U' then s:=playlist else
    if inst='MSU' then s:=currentsong else
    if inst='FNM' then s:=filename else
    if inst='IAL' then s:=AllStats else
    if inst='DIR' then s:=getmp3dir else
    if inst='ADA' then s:=CurrentDate(false) else
    if inst='EDA' then s:=CurrentDate(true) else
    if inst='DOW' then s:=EchtZeller else
    if inst[1]='I' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) {and (attributes >= h)} then s:=attrinfo[h].name else s:=filename;
    end else
    if inst[1]='Y' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) then s:=GrabData(h,2);
    end else
    if inst[1]='Z' then
    begin
      val((inst[2]+inst[3]),h,i);
      {if (h > 0) then s:=GrabCenter(h);}
      if (h > 0) then s:=GrabData(h,13);
    end else
    begin
      changes := true;
      if inst='FTM' then s:=mp3time else
      if inst='STM' then s:=singletime else
      if inst='SMP' then s:=samples else {new 1.5}
      if inst='CDC' then s:=codec else {new 1.5}
      if inst='CPU' then s:=cpu else {new 1.5}
      if inst='BRT' then s:=bitrate else {new 1.5}
      if inst='VLM' then s:=volume else
      if inst='MTR' then s:=MP3bar else
      if inst='ST1' then s:=MpxPlayStats1 else {new 1.5}
      if inst='ST2' then s:=MpxPlayStats2 else {new 1.5}
      if inst='TIM' then s:=CurrentTime(false) else
      if inst='T24' then s:=CurrentTime(true) else

      if inst='BRW' then s:=BrowseLine else
      if (inst[1]='E') and (inst[2]='Q') then
        begin
           val(inst[3],h,i);
           s:=split2eq(h);
        end;
      if (inst[1]='E') then
       begin
         case inst[2] of
           '4':begin
                 val(inst[3],h,i);
                 s:=split4eq(h);
               end;
           '3':begin
                 val(inst[3],h,i);
                 s:=split3eq(h);
               end;
           else
             begin
               val((inst[2]+inst[3]),h,i);
               if (h>0) then s:=ceqbars(11,1,16,h);

             end;
         end;
       end;
     end;
    GetMP3Info := s;
  end;

function MP3Info(b:byte):string;
  var
    s:string;
   begin
     changes := true;
     case b of
       2: s:=center(TimeVol);
       3: s:=center(TimePlayList);
       4: s:=center(MP3bar);
{       5: s:=center(volume);}
       5: s:=TimeEqBitrate;
       6: s:=center(mp3time);
{       7: begin changes := false; s:=center(filename); end;}
       7: s:=center(SongnumSong);
       8: s:=center(AllStats);
       1: begin {1.44}
            if length(attrinfo[1].name)>0 then s:=attrinfo[1].name + ' - '+attrinfo[2].name
              else s:=attrinfo[2].name;
            if (length(s) > lcdlen) then changes := true else changes := false;
            s:=center(s);
          end;
       else begin
         b := b -8;
         s:=center(attrinfo[b].name);
       end;
     end;
     mp3info := s;
 end;

function GetLineInfo(l:byte):string;
  var
    build:string;
    code,i:integer;
    aline:string;
    bchange:boolean;
  begin
    bchange := false;
    build:=''; { Init }
    b:=''; { Init Instruction }
    if LCDLineSet[l].Data[LCDLineSet[l].current].LineValue > 0 then
      begin
        build :=MP3Info(LCDLineSet[l].Data[LCDLineSet[l].current].LineValue);
        bchange := {changes;} FALSE;
      end else
    begin
      aline := LCDLineSet[l].Data[LCDLineSet[l].current].LineString;
      while (length(aline) > 0) do
        begin
          a:=pos('%',aline);
          if (a>0) then
            begin
              build := build + copy(aline,1,a-1); { Get whatever is before %in }
              {Changed for MPXT, convert only the 3 characters to uppercase}
              {Before, we were making the whole string uppercase}
{              b := copy(aline,a+1,3);            { Get instruction (not %)}
              b:=upcase(aline[a+1])+upcase(aline[a+2])+upcase(aline[a+3]);
              aline := copy(aline,a+4,length(aline)); { Update aline }
              build := build + GetMP3Info(b);
              bchange := bchange or changes;
              b := '';
            end
          else begin
            build := build + aline;
            aline := '';
          end;
        end;
        build := center(build);
    end;
    changes := bchange;
    GetLineInfo := build;
  end;



procedure TurnOff;
  var
    l:integer;
  begin
    itson:=false;
    PlayFile:='Nothing';
    lcdclear;
{    for l := 1 to Attributes do attrinfo[l].name := ' ';}
    for l := 1 to 6 do attrinfo[l].name := ''; {1.44}

{    Attributes := 0;}
  end;

{New for 1.5}
Procedure FindBounds;                  {Forget the name, this procedure}
 Var                                    {gets info about the current file}
  current: Byte;                        {that's being played, e.g. band}
  quitearly: Boolean;                   {song title, album, year, genre}
  trackStart, genend: Byte;
  c,lastc: Char;
 Begin                                 {Start by getting the Artist / Track}
  current:=InfoStartCol;                {info}
  b:='';                                  {Empty out the string}
  c:=' ';                                 {Set our char var to a space}
  trackStart:=0;
  quitearly:=false;
  while (current<=InfoEndCol) AND (quitearly=false) do
   Begin
    lastc:=c;                             {Save previous char read}
    c:=(getcharc(current,InfoLine,a));    {Read char}
    if (a <> 15{white}) and (c=#45) then  {If grey dash then that's the}
     begin                                 {divider between Artist/Track}
      trackStart:=length(b);
     end;
    if (c<>' ') OR (lastc<>' ') then     {While there are still characters}
     b:=b+c                                {left to read, keep adding}
      else quitearly:=true;                {characters}
    inc(current);
   End;
  if b[length(b)]=' ' then b:= copy(b,1,length(b)-1);

  if trackStart>0 then
   Begin
    attrinfo[1].name:=copy(b,1,trackstart-1);
    attrinfo[2].name:=copy(b,trackstart+3,length(b)-trackstart-2);
   End
    Else
     Begin
      attrinfo[1].name:='';
      attrinfo[2].name:=b;
     End;
                                       {Get the rest of the ID3 info}
  current:=InfoStartCol;                {album, year, genre, comment}
  b:='';                                  {Empty out the string}
  c:=' ';                                 {Set our char var to a space}
  trackStart:=0;
  a:=0;
  quitearly:=false;
  while (current<=InfoEndCol) AND (quitearly=false) do
   Begin
    lastc:=c;                             {Save previous char read}
    c:=(getchar(current,InfoLine+1));     {Read char}
    if (c='(') then                       {If '(' then start of 'year:'}
     trackStart:=length(b)
      else if (c='[') then                {If '[' then start of 'genre:'}
       a:=length(b)
      else if (c=']') then
       genend:=length(b);                 {If ']' then end of 'genre:'}
    if (c<>' ') OR (lastc<>' ') then     {While there are still characters}
     b:=b+c                                {left to read, keep adding}
      else quitearly:=true;                {characters}
    inc(current);
   End;
  if b[length(b)]=' ' then b:=copy(b,1,length(b)-1);
  if ((trackStart=0) and (a=0)) then     {No year info, no genre info}
   Begin
    attrinfo[3].name:=b;                                  {album}
    attrinfo[4].name:='';                                 {year}
    attrinfo[5].name:='';                                 {genre}
    attrinfo[6].name:='';                                 {comment}
   End
    Else if trackStart=0 then            {No year info, but with genre info}
     Begin
      attrinfo[3].name:=copy(b,1,a-1);
      attrinfo[4].name:='';
      attrinfo[5].name:=copy(b,a+2,genend-a-1);
      attrinfo[6].name:=copy(b,genend+3,length(b));
     End
    Else if a=0 then                     {Year info, but no genre info}
     Begin
      attrinfo[3].name:=copy(b,1,trackStart-1);
      attrinfo[4].name:=copy(b,trackStart+2,4);
      attrinfo[5].name:='';
      attrinfo[6].name:=copy(b,trackstart+8,length(b));
     End
    Else                                 {Year info and genre info}
     Begin
      attrinfo[3].name:=copy(b,1,trackStart-1);
      attrinfo[4].name:=copy(b,trackStart+2,4);
      attrinfo[5].name:=copy(b,a+2,genend-a-1);
      attrinfo[6].name:=copy(b,genend+3,length(b));
     End;
  b:='';
  {Not using GetAllStats procedure anymore.  Since all info is here, it's}
  {easier to build the string with info already read}
  Allstats:=attrinfo[1].name;
  if length(Allstats)>0 then Allstats:=Allstats+' - ';
  Allstats:=Allstats+attrinfo[2].name;
  if length(attrinfo[3].name)>0 then
   Allstats:=Allstats+', '+attrinfo[3].name;
  if length(attrinfo[4].name)>0 then
   Allstats:=Allstats+' ('+attrinfo[4].name+')';
  if length(attrinfo[5].name)>0 then
   Allstats:=Allstats+' ['+attrinfo[5].name+']';
  if length(attrinfo[6].name)>0 then
   Allstats:=Allstats+' '+attrinfo[6].name;
 End;

{procedure FindBounds;
  var start:byte;
      cbound:byte;
      c:char;

  begin
    start := 1;
    cbound := 1;
    Attributes := 0;
    while (cbound < 5) and (start<80) do begin
      if (getchar(start,StatLine) = '{') then bounds[cbound].start := start;
      if (getchar(start,Statline) = ')') then begin
        bounds[cbound].theend := start;
        inc(cbound);
      end;
      inc(start);
    end;

    start := 1;

    b:='';
    while (start < 80) do begin
      c:= (getcharc(start,InfoLine,a));
      if (a = 15) or (c=#32) then begin
        if (length(b)=0) then inc(Attributes);
        if (length(b) < 30) then b := b + c;
      end else begin
        if (length(b) > 0) then begin
          attrinfo[attributes].name := b;
          b:='';
        end;
      end;
      inc(start);
    end;
    if (length(b) > 0) then begin
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
      attrinfo[attributes].name := b;
    end;
    for cbound := 1 to attributes do
      while attrinfo[cbound].name[length(attrinfo[cbound].name)] = ' ' do
        attrinfo[cbound].name := copy(attrinfo[cbound].name,1,length(attrinfo[cbound].name)-1);
    b:='';
    AllStats := GetAllStats;

  end;}



{function playerpaused:boolean;
 var
   b:boolean;
   c:char;

   begin
     if pausecheck then
     if itson then begin
       c:=getchar(33,pauseline);
       if c='v' then b:=false else b:=true;
     end else b := false else b:=false;
     playerpaused := b;
   end;}

{1.44}
 Function playerpaused:boolean;        {Returns true if Mpxplay is paused and}
  Var                                   {pausecheck is enabled}
   b:boolean;
   c:char;
  Begin
   b:=false;
   if pausecheck then
    begin
     c:=getchar(PauseCol,PauseLine);
     if (c='P') then b:=true;
    end;
   playerpaused:=b;
  End;

procedure ResetLCDInfo;
 var a:byte;
     code,i:integer;
  begin
    BrowseString := '';
    for a := 1 to LCDLines do begin
      scrolling[a].on := true;
      scrolling[a].p := 1;
      scrolling[a].pause := ScrollPause;
      scrolling[a].dir := 2;
      scrolling[a].delay := 0;

      displayit[a] := true;

      for i := 1 to LCDLineSet[a].Values do
      begin
        val(LCDLineSet[a].Data[i].LineString,LCDLineSet[a].Data[i].LineValue,code);
      end;
      LCDLineSet[a].Current := 1;
      LCDLineSet[a].Scrolling := LCDLineSet[a].Data[1].LineScroll;
      LCDLineSet[a].DelayTime := LCDLineSet[a].Data[1].LineTime;
      Scrolling[a].on := LCDLineSet[a].Scrolling;

    end;
   numlockstatus := not numlockon; { Force to update }
   lcdtoscreen := false;
   lcdclear;
  end;



{ Is MPX Player Loaded ? }

function MPXLoaded:Boolean;            {Returns true if Mpxplay is running}
var ret:boolean;
    a:byte;
    i:integer;
  begin
    b := '';
{    for i:=1 to 3 do b:=b+(getchar(32+i,1));
    if b = 'MPX' then ret := true else ret := false;}
    for i:=0 to 2 do b:=b+(getchar(MpxCol+i,MpxLine));
    if b = 'Mpx' then ret := true else ret := false; {For Version 1.44}
    ItsOn:=ret;      { Set Player Loaded to On }
    MPXLoaded := ret;
  end;

{function PlayerIsOn:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
    b:string;
  begin

    if (getchar(1,StatLine) = '{') then ret := true
    else ret := false;
    PlayerIsOn := ret;
  end;}

 {For Version 1.44}
 Function PlayerIsOn:Boolean;          {Returns true if MpxPlay is running}
  Var                                   {and a track has been loaded}
   ret:boolean;                        {Track can be either paused or playing}
   i:integer;
   b:string[3];
  Begin
   ret:=false;
   if Itson=true then
    begin
     b:='';
     for i:=0 to 2 do b:=b+(getchar(CodecCol+i,CodecLine));
     if (b<>'Unk') then
      begin
       b:='';
       for i:=0 to 2 do b:=b+(getchar(MpxCol+i,MpxLine));
       if b = 'Mpx' then ret := true;  { Set Player to On}
      end;
    end;
  PlayerIsOn := ret;
 End;


function ValidSong:boolean;
  var ret:boolean;
  begin
    if (PlayFile ='Nothing') or (Playfile = 'No file') then ValidSong:=false else ValidSong := true;
  end;

function MPXPlaying:boolean;
  var ret:boolean;
  begin
    if (ValidSong) or (not playerpaused) then ret := true else ret:=false;
    MPXPlaying:= false;
  end;


procedure ProcessLine(l:byte;var s:string);
  begin
    if (Scrolling[l].on) and (length(s) > LCDLen) then
    begin
      if (scrolling[l].delay >= scrolldelay) then scrolling[l].delay := 0;
      if (scrolling[l].delay = 0) then begin
        case scrolling[l].dir of
          1: begin
               inc(scrolling[l].p);
               if (Scrolling[l].p > length(s)-lcdlen+1) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := ScrollPause;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 2;            { go back! }
                   dec(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   dec(scrolling[l].p);
                 end;
               end;
             end;
        2: begin
             dec(scrolling[l].p);
             if (Scrolling[l].p = 0) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := (ScrollPause div 2)+1;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 1;            { go back! }
                   inc(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   inc(scrolling[l].p);
                 end;
               end;
           end;
         end;
         inc(scrolling[l].delay);
      end else inc(scrolling[l].delay);
      s:=copy(s,scrolling[l].p,scrolling[l].p+lcdlen);
    end; { Scrolling }
  end;

procedure DoBrowse;
var l:byte;
    found :boolean;
    at,atl:byte;
    gs:string;


    procedure showit(la:byte; v:string);
      begin
        processline(la,v);
        if length(v)+2 > lcdlen then
        begin
          v := '>' + v;
          v[lcdlen] := '<';
        end else v := '>' + v + '<';
        lcdprintat(la,center(v));
      end;

  begin
    gs := '';
    l := getblueline;
    at := 1;
    found := false;
    while (at<50) and (not found) do
    begin
      inc(at);
      if getchar(at,l) = '' then found := true;
    end;
    if not found then at := 2 else inc(at);
    begin
      gs := grabrange(l,at);
      if gs <> BrowseString then
      begin
        resetlcdinfo;
        for atl := 1 to lcdlines do scrolling[atl].on := true;
        lcdclear;
        BrowseString := gs;
        if length(gs)+2 > lcdlen then
        begin
          gs := '>' + gs;
          gs[lcdlen] := '<';
        end else gs := '>' + gs + '<';
        case l of
          48: begin
                if LCDLines = 4 then
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-2,at)));
                  LCDPrintAt(2,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(3,centerchop(gs));
                  LCDPrintAt(4,centerchop(grabrange(l+1,at)));
                end else
                begin
                  LCDPrintAt(1,centerchop(gs));
                  LCDPrintAt(2,centerchop(grabrange(l+1,at)));
                end;
              end;
          49: begin
                if LCDLines = 4 then
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-3,at)));
                  LCDPrintAt(2,centerchop(grabrange(l-2,at)));
                  LCDPrintAt(3,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(4,centerchop(gs));
                end else
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(2,centerchop(gs));
                end;
              end
          else
              begin
                if LCDLines=4 then
                begin
                  LCDPrintAt(1,center(grabrange(l-1,at)));
                  LCDPrintAt(2,center(gs));
                  LCDPrintAt(3,center(grabrange(l+1,at)));
                  LCDPrintAt(4,center(grabrange(l+2,at)));
                end else
                begin
                  LCDPrintAt(1,center(gs));
                  LCDPrintAt(2,center(grabrange(l+1,at)));
                end;
             end;
          end; { Case }
      end else
      begin { Scroll it }
        case l of
          48: if LCDLines=4 then showit(3,gs) else showit(1,gs);
          49: if LCDLines=4 then showit(4,gs) else showit(2,gs);
         else if LCDLines=4 then showit(2,gs) else showit(1,gs);
       end;
      end;
    end;
  end;



procedure CheckLCDChange(l:byte);
  begin
    if LCDLineSet[l].Values > 1 then
    begin
      if (LCDLineSet[l].DelayTime = 0) then
        begin
          inc(LCDLineSet[l].Current);
          if LCDLineSet[l].Current > LCDLineSet[l].Values then
            LCDLineSet[l].Current := 1;
          LCDLineSet[l].DelayTime := LCDLineSet[l].Data[LCDLineSet[l].current].LineTime;
          LCDLineSet[l].Scrolling := LCDLineSet[l].Data[LCDLineSet[l].Current].LineScroll;
          displayit[l] := TRUE;
          Scrolling[l].p := 1;
          Scrolling[l].dir := 2;
          scrolling[l].pause := ScrollPause;
          scrolling[l].delay := 0;
        end else
        dec(LCDLineSet[l].DelayTime);
    end;
  end;

Procedure MainTSRProc;
 Var
  l:integer;
  s:string;
 Begin
  if (not Printing) { Not in the interrupt } then
   Begin
    Printing := true;

    Inc(Count);
     If (Count = DelayFactor) Then
      begin
       if PlayerIsOn and (not Paused) and (not ViewFiles) then
        begin
         ItsOn:=true;
         for l := 1 to LCDLines do
          if (not Paused) then
           begin
            CheckLCDChange(l);
            s:=getlineinfo(l);
            if (not Scrolling[l].on) then s := copy(s,1,LCDLEN)
             else ProcessLine(l,s);
            if (l = LCDlines) and (ShowNumLock) then LCDPrintAt(l,copy(s,1,lcdlen-1))
             else LCDPrintAt(l,s);
           end;
         s:=changefactor;
         findbounds;
         if (s <> playfile) then
          begin
           playfile := s;
           findbounds;
           resetlcdinfo;
          end;
        end
         else { Player is On/ Not Paused }
          begin
           if ViewFiles then
            begin
             if numlockon <> numlockstatus then
              numlockstatus := numlockon;
             DoBrowse;
            end
             else
              begin
               if itson and (not paused) then TurnOff;
               playfile := 'Nothing';
               if MPXLoaded then DoBrowse;
              end;
        end;
       Paused := PlayerPaused;
       count := 0;
      end; {Delay Factor }

    Printing := false;
   end; { Endif not printing }

 End;


{$F+}
Procedure LCDOptions; Interrupt;
var mykey :boolean;
begin
  mykey := false;
  if (not InKeyRoutine) and ItsOn and ( not numlockstatus) then begin
    InKeyRoutine := true;
    w:=port[$60];
    if w <> 0 then
      if w = keyLineDown then
        begin
          mykey := true;
          dec(LCDSelected);
          if LCDSelected = 0 then LCDSelected := 1;
        end else
      if w = keyLineUp then
        begin
          mykey := true;
          inc(LCDSelected);
          if LCDSelected > LCDLines then LCDSelected := LCDLines;
       end else
     if w = keyScrollToggle then
      begin
        mykey := true;
        scrolling[lcdselected].on := not scrolling[lcdselected].on;
        Scrolling[lcdselected].p := 1;
        Scrolling[lcdselected].dir := 2;
        scrolling[lcdselected].pause := ScrollPause;
        scrolling[lcdselected].delay := 0;
      end else
     if w = keyPlayView then
       begin
         mykey := true;
         ViewFiles := not ViewFiles
       end else
     if w = keyLineToggle then
       begin
         mykey := true;
         inc(lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue);
{         if (lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue > (8+Attributes)) then}
         if (lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue > (14)) then
    val(LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineString,
      LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue,w);
         scrolling[lcdselected].p := 1;
       end;
    InKeyRoutine := false;
  end;
      Inline($9C);                             { Pushf - Push Flags            }
      Orgint9;                                { Link Old 1C Procedure         }
end;
{$F-}


procedure doit;
Begin
  numlockstatus := not numlockon; { Force to update }
  randomize;
  ExitPlayer:=false;
  Printing:=false;
  keyboardenabled := false;
  PlayFile:='Nothing';
  LCDSelected := 1;
  RefreshDelay:=1; TimetoRefresh:=1;
  ViewFiles:=false;
  itson:=false;
  Count:=0;                    { Clock Pulses Counter                }
  writeln('MpXT TSR for MPXPlay LCD output');
  writeln('Version '+version+' ('+vdate+'), Based on MPXF by Scott Bradshaw.');
  writeln;
  write('Loading config...');
  DoConfig;
  writeln('Done!');             { $1C}
  initlcd;                       { Of Main Program                     }
  eq_bars;
  lcdtoscreen := true;
 {$IFDEF serkey}
  if UsingSerial then
  begin
    if fileexists(codefile) then
      begin
        writeln('Loading Serialport keypad config...');
        writeln('   (delete this file if you wish to assign new keys)');
        KeyLoadConfig(codefile);
        KeyStart;
      end
      else
      begin
        KeyStart;
        writeln('Setting up new keys for serial port keypad..');
        writeln('Press Enter..');
        readln;
        KeyAddKeys;
        writeln('Saving config for next use.');
        KeySaveConfig(codefile);
      end;
  end;
 {$ENDIF}

  LCDtoScreen := false;
  ViewFiles := false;
  if keyboardenabled then begin
    GetIntVec(9, @OrgInt9);
    SetIntVec(9, Addr(LCDOptions));
    writeln('Keyboard enabled!');
  end;

  LCDClear;
  if (DrawLogo) then TSRLogo;
  writeln('MpXT TSR Loaded.');
End;



begin
end.
